program pc2zx(input,output) ;

{*******************************************************************}
{*  PC-ZX Version 3.0                                              *}
{*  LOADing .SNA added                                             *}
{*  3 names/line in DIR by requests, 2 names/line names by *.*     *}
{*******************************************************************}
{*  PC-ZX Version 2.2                                              *}
{*  Dir command improved                                           *}
{*******************************************************************}
{*  PC-ZX Version 2.1                                              *}
{*  LOAD "not found" improved                                      *}
{*  MDDIR RMDIR improved                                           *}
{*******************************************************************}
{*  PC-ZX Version 2.0                                              *}
{*  LOADing .Z80 added                                             *}
{*******************************************************************}
{*  PC-ZX Version 1.0                                              *}
{*  First version of PC<->ZX Interface serversoftware              *}
{*******************************************************************}

uses crt,dos ;

type
    fob = file of byte;
    arofb = packed array[1..50000] of byte;


var
    ba:integer;
    station : integer;
    inactivefile,path,tempname : string;
    commando : packed array[1..2] of char;
    dir : searchrec;
    mem : arofb ;
    count,count1,count2,position : longint;
    choice : char;
    a,b,c,x : byte ;
    p,q,r,s : word;
    name : string;
    name2:string;
    name3:string;
    best2,best1 : fob ;
    best : file;
    space :boolean;
    f,f2: fob;
    k:byte;
    t,tel:longint;
    st:string;
    namecount:integer;
    loader : packed array[1..100] of byte;

function idname(d:string;n3:string;var x:integer;name :string): string;
var
   s: string;
   t: integer;

begin
    s:=d;
    if n3<>'*.*' then
    begin
       t:=1;
       s:='';
       while (t<length(d)) and (d[t]<>'.') do
       begin
          s:=s+d[t];
          t:=t+1;
       end;
       s:=s+'. ';
       while length(s)<10 do
          s:=' '+s;
    end;
    if d=name then s:=chr(20)+chr(1)+s+chr(20)+chr(0);
    x:=x+1;
    if (n3='*.*') then
    begin
       s:=s+chr(6);
       x:=1;
    end;
    if x=3 then x:=0 else if n3<>'*.*' then s:=s+' ';
    if x=0 then s:=s+chr(13);
    idname:=s;
end;

function open (var bestand : fob ;
                   name : string ) : boolean ;

var dir : searchrec;

begin
   assign(bestand,name) ;
   {$I-}
   reset(bestand);
   {$I+}
   findfirst(name,anyfile,dir);
   open :=( doserror = 0);   { open = true, bestand aanwezig  }
end ;

function spectrum2pc( f:byte):byte;

var t,c,x : byte;

begin
   repeat
      c:=8;
      port[ba]:=c;
      {* high nibble *}
      repeat
         x:= port[ba+1] ;
      until x and 128 = 0 ;
      repeat
         if x and 128=0 then c:= x div 8 ;
         port[ba]:=c+16;
         x:= port[ba+1] ;
      until x and 128= 128;
   until (f=255) or (c<8);
   port[ba]:=c;
   {* low nibble *}
   repeat
      x:= port[ba+1] ;
   until x and 128= 0 ;
   repeat
      if x and 128= 0 then t:= x div 8 ;
      port[ba]:=t+16;
      x:= port[ba+1];
   until x and 128 = 128;
   port[ba]:=t;
   spectrum2pc:=c*16+t;
end;

procedure pc2spectrum(y:byte);
var t,x : byte;


begin
   {* high nibble *}
   t:= y div 16;
   repeat
      port[ba]:=t;       {* DATA to Spectrum *}
      x:= port[ba+1] ;
   until t= x div 8 ; {* only when data=correct and signal Spectrum*}
   repeat
      port[ba]:=t+16;
      x:= port[ba+1] and 128;
   until x = 128;
   {* low nibble *}
   t:= y mod 16;
   repeat
      port[ba]:=t;       {* DATA to Spectrum *}
      x:= port[ba+1] ;
   until t= x div 8 ; {* only when data=correct and signal Spectrum*}
   repeat
      port[ba]:=t+16;
      x:= port[ba+1] and 128;
   until x = 128;
   port[ba]:=t;
end;


procedure decomp(var tel,count:longint;x:longint;compression:boolean);

var tel2 : longint;

begin
   tel:=tel+256;
   while tel>x+256 do
   begin
      if (mem[count-2]=237) and (mem[count-3] =237) and compression then
      begin
         for tel2:= 1 to mem[count-1] do
         begin
            mem[tel]:=mem[count];
            tel:=tel-1;
         end;
         count:=count-4;
      end
      else
      begin
         mem[tel]:=mem[count];
         tel:=tel-1;
         count:=count-1;
      end;
   end;
   tel:=tel-256;
end;

procedure senddata(var mem: arofb ; var okz80:boolean);

var x,c,t : longint;

begin
   loader[1]:=19; loader[2]:=0; loader[3]:=0 ; loader[4]:=0;
   loader[5]:=108; loader[6]:=111; loader[7]:=97 ; loader[8]:=100;
   loader[9]:=101; loader[10]:=114; loader[11]:=32 ; loader[12]:=32;
   loader[13]:=32; loader[14]:=32; loader[15]:=23 ; loader[16]:=0;
   loader[17]:=0; loader[18]:=0; loader[19]:=23 ; loader[20]:=0;
   loader[21]:=17; loader[22]:=25; loader[23]:=0 ; loader[24]:=255;
   loader[25]:=0; loader[26]:=1; loader[27]:=19 ; loader[28]:=0;
   loader[29]:=239; loader[30]:=34;  loader[31]:=34 ;  loader[32]:=170;
   loader[33]:=58;  loader[34]:=249; loader[35]:=192 ; loader[36]:=49;
   loader[37]:=54;  loader[38]:=51;  loader[39]:=56 ;  loader[40]:=52;
   loader[41]:=14;  loader[42]:=0;   loader[43]:=0 ;   loader[44]:=0;
   loader[45]:=64;  loader[46]:=0;   loader[47]:=13 ;  loader[48]:=208;
   loader[61]:=19;  loader[62]:=0;   loader[63]:=0;    loader[64]:=3;
   loader[65]:=170; loader[66]:=32;  loader[67]:=32;   loader[68]:=32;
   loader[69]:=32;  loader[70]:=32;  loader[71]:=32;   loader[72]:=32;
   loader[73]:=32;  loader[74]:=32;  loader[75]:=0;    loader[76]:=27;
   loader[77]:=0;   loader[78]:=64;  loader[79]:=0;    loader[80]:=128;
   loader[81]:=82;  loader[82]:=2;   loader[83]:=27;   loader[84]:=255;
   if not okz80 then loader[48]:=76; {* Create LOAD Error in HEADER *}
   x:=255;
   pc2spectrum(loader[3]); {* initial byte header data *}
   t:=spectrum2pc(x); t:=spectrum2pc(x); {* skip header info *}
   for t:=1 to 18 do
      pc2spectrum(loader[t+3]);
   t:=spectrum2pc(x); {* L from LOAD *}
   pc2spectrum(loader[24]);
   t:=spectrum2pc(x);t:=spectrum2pc(x);
   for t:= 1 to 24 do
      pc2spectrum(loader[t+24]);
   if okz80 then
   begin
      t:=spectrum2pc(x); {* L from LOAD *}
      pc2spectrum(loader[63]);
      t:=spectrum2pc(x);t:=spectrum2pc(x);
      for t:= 1 to 18 do
         pc2spectrum(loader[t+63]);
      t:=spectrum2pc(x); {* L from LOAD *}
      pc2spectrum(loader[84]);
      t:=spectrum2pc(x);t:=spectrum2pc(x);
      c:=255;
      for t:= 1 to 6912 do
      begin
         pc2spectrum(mem[t+256]);
         c:=c xor mem[t+256];
      end;
      pc2spectrum(c);
      t:=spectrum2pc(x); {* L from LOAD *}
      pc2spectrum(loader[84]);
      t:=spectrum2pc(x);t:=spectrum2pc(x);
      c:=255;
      for t:= 6913 to 49152 do
      begin
         pc2spectrum(mem[t+256]);
         c:=c xor mem[t+256];
      end;
      pc2spectrum(c);
   end;
end;


procedure inlezenSNA(var best2: fob ; var mem : arofb; name : string);

var count : longint;
    best: file ;
    compression,okz80,version1 : boolean;
    tel,tel2 : longint;
    c:byte;

begin
   reset(best2);
   count:=0;
   if filesize(best2) div 128 > 0 then
   begin
      assign(best,name);       {* block level *}
      reset(best);
      count:= filesize(best2) div 128;   {* number of blocks *}
      if count > 390 then count := 390 ;    {* MAX load 49920 bytes *}
      blockread(best,mem,count);
      close(best);
   end;
   count := count * 128 ;
   seek(best2,count);
   while (filesize(best2) > filepos(best2)) and (filepos(best2)<49990) do
       {* again MAX load 49990 bytes *}
   begin
      count:=count+1;
      read(best2,c);
      mem[count]:=c;
   end;
   {* MEM1..MEMnnnn is file *}
   for count2 := count downto 257 do
   begin
      mem[count2]:=mem[count2-256+27] ;
   end;
   mem[257]:=243;                                        {* DI             *}
   mem[258]:=49;mem[259]:=96;mem[260]:=64;               {* LD SP,16480    *}
   mem[261]:=62 ; mem[262]:=255;                         {* LD A,255       *}
   mem[263]:=221; mem[264]:=33;mem[265]:=0;mem[266]:=91; {* LD IX,23296    *}
   mem[267]:=17;mem[268]:=0;mem[269]:=165;               {* LD DE,41440    *}
   mem[270]:=55;                                         {* SCF            *}
   mem[271]:=205;mem[272]:=86;mem[273]:=5;               {* CALL #556      *}
   mem[274]:=243;                                        {* DI             *}
   mem[275]:= 62; mem[276] := mem[27] ;                  {* LD A,N         *}
   mem[277]:= 211 ; mem[278] := 254;                     {* OUT (254),A    *}
   mem[279]:=33;mem[280]:=mem[8];mem[281]:=mem[9];       {* LD HL,NNNN     *}
   mem[282]:=229;                                        {* PUSH HL        *}
   mem[283]:=241;                                        {* POP AF         *}
   mem[284]:=8;                                          {* EX AF,AF'      *}
   mem[285]:=33;mem[286]:=mem[2];mem[287]:=mem[3];       {* LD HL,NNNN     *}
   mem[288]:=17;mem[289]:=mem[4];mem[290]:=mem[5];       {* LD DE,NNNN     *}
   mem[291]:= 1;mem[292]:=mem[6];mem[293]:=mem[7];       {* LD BC,NNNN     *}
   mem[294]:=217;                                        {* EXX            *}
   mem[295]:=33;mem[296]:=mem[22];mem[297]:=mem[23];     {* LD HL,NNNN     *}
   mem[298]:=229;                                        {* PUSH HL        *}
   mem[299]:=33;mem[300]:=mem[10];mem[301]:=mem[11];     {* LD HL,NNNN     *}
   mem[302]:=17;mem[303]:=mem[12];mem[304]:=mem[13];     {* LD DE,NNNN     *}
   mem[305]:=1;mem[306]:=mem[14];mem[307]:=mem[15];      {* LD BC,NNNN     *}
   mem[308]:=221;mem[309]:=33;
   mem[310]:=mem[18];mem[311]:=mem[19];                  {* LD IX,NNNN     *}
   mem[312]:=253;mem[313]:=33;
   mem[314]:=mem[16];mem[315]:=mem[17];                  {* LD IY,NNNN     *}
   mem[316]:=62;mem[317]:=mem[1];                        {* LD A,N         *}
   mem[318]:=237;mem[319]:=71;                           {* LD I,A         *}
   mem[320]:=241;                                        {* POP AF         *}
   mem[321]:=49;mem[322]:=mem[24];mem[323]:=mem[25];     {* LD SP,NNNN     *}
   mem[324]:=237;
   c:= mem[26];
   if c=0 then mem[325]:= 70 else mem[325]:=78+c*8;      {* IM 0/1/2       *}
   if mem[20] and 4=0 then mem[326]:=243 else mem[326]:=251;   {* EI/DI          *}
   mem[327]:=201;                                        {* RET            *}
   okz80:=true;
   senddata(mem,okz80);
end;

procedure inlezenZ80(var best2: fob ; var mem : arofb; name : string);

var count : longint;
    best: file ;
    compression,okz80,version1 : boolean;
    tel,tel2 : longint;
    c:byte;

begin
   reset(best2);
   count:=0;
   if filesize(best2) div 128 > 0 then
   begin
      assign(best,name);       {* block level *}
      reset(best);
      count:= filesize(best2) div 128;   {* number of blocks *}
      if count > 390 then count := 390 ;    {* MAX load 49920 bytes *}
      blockread(best,mem,count);
      close(best);
   end;
   count := count * 128 ;
   seek(best2,count);
   while (filesize(best2) > filepos(best2)) and (filepos(best2)<49990) do
       {* again MAX load 49990 bytes *}
   begin
      count:=count+1;
      read(best2,c);
      mem[count]:=c;
   end;
   {* MEM1..MEMnnnn is file *}
   okz80 := true;
   version1 := true;
   if mem[7] + mem[8] = 0 then
   begin
      version1:= false;
      okz80 := (mem[35] < 2);
   end;
   if version1 then
      compression := (mem[13] and 32 = 32)
   else
      compression :=true;
   tel:=49152;
   if version1 and compression then count:=count-4;
   decomp(tel,count,32768,compression);
   if not version1 then {* pointer 49152-65535 blok 5*}
   begin
      count:=mem[31]+33;
      count:=count+3+mem[count]+256*mem[count+1];
      count:=count+2+mem[count]+256*mem[count+1];
   end;
   decomp(tel,count,16384,compression);
   if not version1 then {* pointer 32768-49151 blok 4*}
   begin
      count:=mem[31]+33;
      count:=count+2+mem[count]+256*mem[count+1];
   end;
   decomp(tel,count,0,compression);
   if not version1 then
   begin
      for count:=32769 to 49152 do
      begin
         c:=mem[count+256];mem[count+256]:=mem[count+256-16384];
         mem[count+256-16384]:=c;
      end;
      for count:=16385 to 32768 do
      begin
         c:=mem[count+256];mem[count+256]:=mem[count+256-16384];
         mem[count+256-16384]:=c;
      end;
   end;
   mem[257]:=243;                                        {* DI             *}
   mem[258]:=49;mem[259]:=96;mem[260]:=64;               {* LD SP,16480    *}
   mem[261]:=62 ; mem[262]:=255;                         {* LD A,255       *}
   mem[263]:=221; mem[264]:=33;mem[265]:=0;mem[266]:=91; {* LD IX,23296    *}
   mem[267]:=17;mem[268]:=0;mem[269]:=165;               {* LD DE,41440    *}
   mem[270]:=55;                                         {* SCF            *}
   mem[271]:=205;mem[272]:=86;mem[273]:=5;               {* CALL #556      *}
   mem[274]:=243;                                        {* DI             *}
   mem[275]:= 62; mem[276] := (mem[13] and 14) div 2 ;   {* LD A,N         *}
   mem[277]:= 211 ; mem[278] := 254;                     {* OUT (254),A    *}
   mem[279]:=33;mem[280]:=mem[23];mem[281]:=mem[22];     {* LD HL,NNNN     *}
   mem[282]:=229;                                        {* PUSH HL        *}
   mem[283]:=241;                                        {* POP AF         *}
   mem[284]:=8;                                          {* EX AF,AF'      *}
   mem[285]:=33;mem[286]:=mem[20];mem[287]:=mem[21];     {* LD HL,NNNN     *}
   mem[288]:=17;mem[289]:=mem[18];mem[290]:=mem[19];     {* LD DE,NNNN     *}
   mem[291]:= 1;mem[292]:=mem[16];mem[293]:=mem[17];     {* LD BC,NNNN     *}
   mem[294]:=217;                                        {* EXX            *}
   mem[295]:=33;mem[296]:=mem[2];mem[297]:=mem[1];       {* LD HL,NNNN     *}
   mem[298]:=229;                                        {* PUSH HL        *}
   mem[299]:=33;mem[300]:=mem[5];mem[301]:=mem[6];       {* LD HL,NNNN     *}
   mem[302]:=17;mem[303]:=mem[14];mem[304]:=mem[15];     {* LD DE,NNNN     *}
   mem[305]:=1;mem[306]:=mem[3];mem[307]:=mem[4];        {* LD BC,NNNN     *}
   mem[308]:=221;mem[309]:=33;
   mem[310]:=mem[26];mem[311]:=mem[27];                  {* LD IX,NNNN     *}
   mem[312]:=253;mem[313]:=33;
   mem[314]:=mem[24];mem[315]:=mem[25];                  {* LD IY,NNNN     *}
   mem[316]:=62;mem[317]:=mem[11];                       {* LD A,N         *}
   mem[318]:=237;mem[319]:=71;                           {* LD I,A         *}
   mem[320]:=241;                                        {* POP AF         *}
   mem[321]:=49;mem[322]:=mem[9];mem[323]:=mem[10];      {* LD SP,NNNN     *}
   mem[324]:=237;
   c:= mem[30] and 3;
   if c=0 then mem[325]:= 70 else mem[325]:=78+c*8;      {* IM 0/1/2       *}
   if mem[28]=0 then mem[326]:=243 else mem[326]:=251;   {* EI/DI          *}
   mem[327]:=195;
   if version1 then
   begin
      mem[328]:=mem[7];mem[329]:=mem[8];
   end
   else
   begin
      mem[328]:=mem[33];mem[329]:=mem[34];
   end;                                                  {* JP NNNN        *}
   senddata(mem,okz80);
end;



procedure load(var best2: fob ; var len : longint; name : string ;
               var mem : arofb);

var
   x : byte;
   best : file ;
   count,count1,count2,position : longint;

begin
   position := filepos(best2);
   count:= filesize(best2)-position;
   if count > len then count2:=len else count2 := count;
   if count2 div 128 > 0 then
   begin
      count2:=count2+(position mod 128);
      assign(best,name);       {* block level *}
      reset(best);
      seek(best,position div 128);
      count2:= count2 div 128;
      seek(best2,(position div 128)*128+count2*128);
      blockread(best,mem,count2);
      close(best);
      for count :=  position mod 128+1 to 128*count2 do
      begin
         pc2spectrum(mem[count]);
         len:=len-1;
      end;
   end;
   for count := 1 to len do
   begin
      mem[1]:=count mod 256;
      if filepos(best2)<filesize(best2) then
         read(best2,mem[1]);
      pc2spectrum(mem[1]);
   end;
end;

procedure save(var best2: fob ; var len : longint; name : string ;
               var mem : arofb);

var
   x : byte;
   count,count1  : longint;
   best : file;

begin
   while  (len >0) and (filepos(best2) mod 128 <> 0) do
   begin
      x:=spectrum2pc(255);
      write(best2,x);
      len:=len-1;
   end;
   if len >= 128 then
   begin
      close(best2);
      count := len div 128;
      for count1 := 1 to count * 128 do
      begin
         mem[count1]:= spectrum2pc(255);
      end;
      len := len - 128 * count;
      assign(best,name);
      reset(best);
      seek(best,filesize(best));
      blockwrite(best,mem,count);
      close(best);
      assign(best2,name);
      reset(best2);
      seek(best2,filesize(best2));
   end;
   while  (len > 0) do
   begin
      x:=spectrum2pc(255);
      write(best2,x);
      len:=len-1;
   end;
   x:=spectrum2pc(255);
   write(best2,x);
end;

begin
   ba:=$378;
   if paramstr(1)='2' then ba:= $278;
   if paramstr(1)='3' then ba:= $3e8;
   if paramstr(1)='4' then ba:= $2e8;
   clrscr;
   findfirst('c:\temp',anyfile,dir);
   if doserror<>0 then mkdir('c:\temp');
   station:=3;  {* C = active disk *}
   chdir ('c:.\');
   inactivefile:='c:\temp\unknown';
   name := inactivefile;
   textcolor(black);
   textbackground(black);
   clrscr;
   assign(best2,name);  {* point to inactive file *}
   rewrite(best2);
   close(best2);
   assign(best2,name);
   reset(best2);
   clrscr;
   repeat
      repeat
         choice := upcase(chr(spectrum2pc(0)));
         {* D = DIR to Spectrum       *}
         {* E = ERASE FILE            *}
         {* S = SAVE                  *}
         {* L = LOAD                  *}
         {* O = OPEN FILE             *}
         {* X = eXit PC-PROGRAM       *}
         {* C = DOS DIR COMMANDS      *}
      until choice in ['C','D','E','S','L','O','X'];
      case choice of
      'L' : begin
               if name[length(name)]<>'P' then    {* not .tap-file *}
               begin
                  case  name[length(name)] of
                  '0' : inlezenZ80(best2,mem,name);
                  'A' : inlezenSNA(best2,mem,name);
                  end;
               end
               else
               begin
                  count1 :=0;
                  x:=233;  {* no standard initial byte *}
                  if filepos(best2)>=filesize(best2) then
                     seek(best2,0);
                  if filepos(best2)<filesize(best2) then
                  begin
                     read (best2,a);
                     read (best2,b);
                     count1 := a + trunc(b/4 * 1024)-2 ;   {* length in file *}
                     read (best2,x);
                  end;
                  position := filepos(best2)+count1+1;
                  pc2spectrum(x);                 {* initial byte   *}
                  x:=255;
                  a := spectrum2pc(x);
                  b := spectrum2pc(x);
                  count := a + trunc(b/4 * 1024) + 1;    {* length to load *}
                  load (best2,count,name,mem);
                  if position>=filesize(best2) then position := 0;
                  seek(best2,position);
               end;
            end;
      'S' : begin
               if name[length(name)]<>'P' then
               begin
                  name:=inactivefile;
                  assign(best2,name);
                  reset(best2);
               end; {* no save to not .tap-file *}
               {* SAVE TO FILE *}
               seek(best2,filesize(best2)); {* naar einde file *}
               a := spectrum2pc(255);
               b := spectrum2pc(255) ;
               count := a + trunc(b/4*1024) ;
               count1 := count + 2;
               a:= count1 mod 256;
               b:= count1 div 256;
               write (best2,a);
               write (best2,b);
               count1:=count1-1;
               save(best2,count1,name,mem);  {* 1 more=initial,check in save*}
            end;
      'O' : begin
               {* OPEN FILE *}
               a:=spectrum2pc(255);
               b:=spectrum2pc(255);
               count := a + trunc(b/4*1024); {* length of filename *}
               name := '';
               for count1 := 1 to count do
               begin
                  name := name + upcase(chr(spectrum2pc(255)));
               end;
               if name='' then name := 'AUTO';
               close (best2);
               if name[length(name)-3]<> '.' then name:= name + '.TAP';
               findfirst('.\'+name,anyfile,dir);
               if doserror<>0 then
               begin
                  assign(best2,name);
                  rewrite(best2);
                  close(best2);
               end;
               assign(best2,name);
               reset(best2);
            end;
      'D' : begin
               namecount:=0;
               {* DIR to SPECTRUM *}
               name3:='';
               a:=spectrum2pc(255);
               b:=spectrum2pc(255);
               count := a + trunc(b/4*1024); {* length of filename *}
               for count1 := 1 to count do
               begin
                  name3 := name3 + upcase(chr(spectrum2pc(255)));
               end;
               if name3='' then name3:='*.TAP';
               findfirst('.\'+name3,anyfile-directory,dir);
               while doserror=0 do
               begin
                  name2:=idname(dir.name,name3,namecount,name);
                  for count := 1 to length(name2) do
                     pc2spectrum(ord(name2[count]));
                  findnext(dir);
               end;
               if name2 ='' then name2:='NO FILES FOUND'+#13
               else name2 :=#13;
               getdir(station,path);
               name2:=name2+#13+path+'\'+name3+#13;
               for count:=1 to length(name2) do
                  pc2spectrum(ord(name2[count]));
               name2:='';
               findfirst('.\*.*',directory,dir);
               while doserror=0 do
               begin
                  name2:='';
                  if dir.attr = 16 then
                  begin
                     for count:=length(dir.name) to 12 do
                        name2:=name2+' ';
                     name2:=name2+dir.name+'   ';
                     for count:=1 to length(name2) do
                       pc2spectrum(ord(name2[count]));
                  end;
                  findnext(dir);
               end;
               name2:=#13+chr(128);
               for count:=1 to length(name2) do
                 pc2spectrum(ord(name2[count]));
            end;
      'E' : begin
               {* ERASE FILE *}
               a:=spectrum2pc(255);
               b:=spectrum2pc(255);
               count := a + trunc(b/4*1024); {* length of filename *}
               name2 := '';
               for count1 := 1 to count do
               begin
                  name2 := name2 + chr(spectrum2pc(255));
               end;
               if name2='' then name2:='@#YRS!@#.YRS'; {*not existing name*}
               name2:=name2+'.tap' ;
               findfirst(name2,anyfile,dir);
               if doserror=0 then
               begin
                  assign(best1,name2);
                  erase(best1);
                  if name2=name then
                  begin
                     name := inactivefile;
                     assign(best2,name);
                     reset(best2);
                  end;
                  {* no active TAP-file anymore *}
               end;
            end;
      'C' : begin
               a:=spectrum2pc(255);
               b:=spectrum2pc(255);
               count := a + trunc(b/4*1024); {* length of filename *}
               name := '';
               for count1 := 1 to count do
               begin
                  name := name + upcase(chr(spectrum2pc(255)));
               end;
               tempname := '';
               count1:=3;
               space:=true;
               while (count1<=count) do
               begin
                  space:=space and (name[count1]=' ');
                  if not space then tempname:=tempname+name[count1];
                  count1:=count1+1;
               end;
               commando[1]:= name[1];
               commando[2]:= name[2];
               if commando = 'CD' then
               begin
                  if (tempname[2]=':') and (length(tempname)>1) then
                      station := ord(upcase(tempname[1]))-64;
                  findfirst(tempname+'\*.*',anyfile,dir);
                  if doserror=0 then chdir(tempname);
                  close(best2);
                  name:=inactivefile;
                  assign(best2,name);
                  reset(best2);
                  getdir(station,tempname);
               end;
               findfirst(tempname+'\*.*',anyfile,dir);
               if (doserror>0) and (commando = 'MD') then mkdir(tempname);
               if (doserror=0) and (commando = 'RD') then rmdir(tempname);
            end;
      end;
   until choice = 'X';
   textcolor(white);
   clrscr;
   close(best2);
   assign(best2,inactivefile);
   rewrite(best2);
   erase(best2);
   close(best2);
end.
